> ## Documentation Index
> Fetch the complete documentation index at: https://docs.serval.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List Ticket External Messages

> List all origin external messages for a ticket. These are messages that originated from external systems and were synced into Serval. This helps you understand which messages came from which external channels.



## OpenAPI

````yaml /sections/api-reference/openapi-spec-v2.yaml get /v2/tickets/{ticket_id}/external-messages
openapi: 3.1.0
info:
  title: Serval Public API
  description: Serval Public API
  contact:
    name: Serval
    url: https://serval.com
    email: support@serval.com
  license:
    name: Serval License
    url: https://serval.com/license
  version: 2.0.0
servers:
  - url: https://public.api.serval.com
security:
  - BearerAuth: []
tags:
  - name: Access Policy API
  - name: Access Policy Approval Procedure API
  - name: Access Profile API
  - name: Access Relationship API
  - name: Access Request API
  - name: Agent API
  - name: App Instance API
  - name: App Resource API
  - name: App Resource Role API
  - name: Approval Delegation API
  - name: Approval Request API
  - name: Audit Log API
  - name: Change Blackout API
  - name: Change Model API
  - name: Custom Field API
  - name: Custom Service API
  - name: Entity API
  - name: Entity Field Mapping API
  - name: Entity Ingestion Config API
  - name: Entity Type API
  - name: Folder API
  - name: Group API
  - name: Guidance API
  - name: Help Agent API
  - name: Journey API
  - name: Knowledge API
  - name: Knowledge Base API
  - name: Report API
  - name: SLA API
  - name: Schedule API
  - name: Tag API
  - name: Team API
  - name: Team User API
  - name: Ticket API
  - name: Topic API
  - name: User API
  - name: User Relationship API
  - name: Workflow API
  - name: Workflow Approval Procedure API
  - name: Workflow Run API
paths:
  /v2/tickets/{ticket_id}/external-messages:
    get:
      tags:
        - Ticket API
      summary: List Ticket External Messages
      description: >-
        List all origin external messages for a ticket. These are messages that
        originated from external systems and were synced into Serval. This helps
        you understand which messages came from which external channels.
      operationId: svrelay.publicv2.PublicAPIServiceV2.ListTicketExternalMessages
      parameters:
        - name: ticket_id
          in: path
          required: true
          schema:
            type: string
            title: ticket_id
            description: The ID of the Serval ticket to list external messages for
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/svhelp.publicapi.ListTicketExternalMessagesResponse
        default:
          description: Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/connect.error'
      security:
        - BearerAuth: []
components:
  schemas:
    svhelp.publicapi.ListTicketExternalMessagesResponse:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/svhelp.pubapimodels.ExternalMessage'
          title: data
          x-stainless-terraform-configurability: optional
      title: ListTicketExternalMessagesResponse
      additionalProperties: false
    connect.error:
      type: object
      properties:
        code:
          type: string
          examples:
            - not_found
          enum:
            - canceled
            - unknown
            - invalid_argument
            - deadline_exceeded
            - not_found
            - already_exists
            - permission_denied
            - resource_exhausted
            - failed_precondition
            - aborted
            - out_of_range
            - unimplemented
            - internal
            - unavailable
            - data_loss
            - unauthenticated
          description: >-
            The status code, which should be an enum value of
            [google.rpc.Code][google.rpc.Code].
          x-stainless-terraform-configurability: optional
        message:
          type: string
          description: >-
            A developer-facing error message, which should be in English. Any
            user-facing error message should be localized and sent in the
            [google.rpc.Status.details][google.rpc.Status.details] field, or
            localized by the client.
          x-stainless-terraform-configurability: optional
        detail:
          $ref: '#/components/schemas/google.protobuf.Any'
          x-stainless-terraform-configurability: optional
      title: Connect Error
      additionalProperties: true
      description: >-
        Error type returned by Connect:
        https://connectrpc.com/docs/go/errors/#http-representation
    svhelp.pubapimodels.ExternalMessage:
      type: object
      properties:
        id:
          type: string
          title: id
          description: The ID of the external message in Serval's system
          readOnly: true
          x-stainless-terraform-configurability: computed
        externalMessageId:
          type: string
          title: external_message_id
          description: The ID of the external message in the external system
          readOnly: true
          x-stainless-terraform-configurability: computed
        messageId:
          type: string
          title: message_id
          description: The ID of the Serval message this external message is linked to
          readOnly: true
          x-stainless-terraform-configurability: computed
        sourceType:
          $ref: '#/components/schemas/svhelp.pubapimodels.ExternalMessageSourceType'
          title: source_type
          description: The type of external system (Slack, Jira, Email, etc.)
          readOnly: true
          x-stainless-terraform-configurability: computed
        sourceId:
          type: string
          title: source_id
          description: The ID of the source/integration in Serval
          readOnly: true
          x-stainless-terraform-configurability: computed
        isOrigin:
          type: boolean
          title: is_origin
          description: >-
            Whether this external message is the origin source of the Serval
            message
             True if the Serval message was created from this external message
          readOnly: true
          x-stainless-terraform-configurability: computed
        createdAt:
          $ref: '#/components/schemas/google.protobuf.Timestamp'
          title: created_at
          description: Timestamp when the external message link was created
          readOnly: true
          x-stainless-terraform-configurability: computed
        updatedAt:
          $ref: '#/components/schemas/google.protobuf.Timestamp'
          title: updated_at
          description: Timestamp when the external message link was last updated
          readOnly: true
          x-stainless-terraform-configurability: computed
        toRecipientEmails:
          type: array
          items:
            type: string
            readOnly: true
          title: to_recipient_emails
          description: |-
            Email-specific fields (only populated when source_type is EMAIL)
             The To recipient email addresses
          readOnly: true
          x-stainless-terraform-configurability: computed
        ccRecipientEmails:
          type: array
          items:
            type: string
            readOnly: true
          title: cc_recipient_emails
          description: The CC recipient email addresses
          readOnly: true
          x-stainless-terraform-configurability: computed
      title: ExternalMessage
      additionalProperties: false
      description: >-
        ExternalMessage represents a Serval message's connection to an external
        system
    google.protobuf.Any:
      type: object
      properties:
        type:
          type: string
          x-stainless-terraform-configurability: optional
        value:
          type: string
          format: binary
          x-stainless-terraform-configurability: optional
        debug:
          type: object
          additionalProperties: true
          x-stainless-terraform-configurability: optional
      additionalProperties: true
      description: >-
        Contains an arbitrary serialized message along with a @type that
        describes the type of the serialized message.
    svhelp.pubapimodels.ExternalMessageSourceType:
      type: string
      title: ExternalMessageSourceType
      enum:
        - EXTERNAL_MESSAGE_SOURCE_TYPE_UNSPECIFIED
        - EXTERNAL_MESSAGE_SOURCE_TYPE_SLACK
        - EXTERNAL_MESSAGE_SOURCE_TYPE_LINEAR
        - EXTERNAL_MESSAGE_SOURCE_TYPE_EMAIL
        - EXTERNAL_MESSAGE_SOURCE_TYPE_JIRA
        - EXTERNAL_MESSAGE_SOURCE_TYPE_PUBLIC_API
        - EXTERNAL_MESSAGE_SOURCE_TYPE_FRESHSERVICE
        - EXTERNAL_MESSAGE_SOURCE_TYPE_ZENDESK
        - EXTERNAL_MESSAGE_SOURCE_TYPE_SERVICENOW
        - EXTERNAL_MESSAGE_SOURCE_TYPE_PHONE_CALL
        - EXTERNAL_MESSAGE_SOURCE_TYPE_MICROSOFT
      description: External message source types
    google.protobuf.Timestamp:
      type: string
      format: date-time
      description: A timestamp in RFC 3339 format (e.g., "2025-01-15T01:30:15Z").
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer

````